require 'spec_helper'

RSpec.describe CorrelationId::Middleware::Airbrake do
  let(:project_id) { 123_456 }
  let(:project_key) { 'project_key' }
  let(:airbrake_endpoint) do
    "https://airbrake.io/api/v3/projects/#{project_id}/notices"
  end

  before do
    Airbrake.configure do |c|
      c.project_id = project_id
      c.project_key = project_key
    end

    Airbrake.add_filter(CorrelationId::Middleware::Airbrake)
  end

  describe 'X-Correlation-ID' do
    before do
      stub_request(:post, airbrake_endpoint).to_return(status: 201)
      Airbrake.notify_sync('my error')
    end

    it 'sets header' do
      body = /"correlation_id":"#{CorrelationId.uuid}"/
      expect(a_request(:post, airbrake_endpoint).with(body: body)).to have_been_made.once
    end
  end
end
