RSpec.shared_examples 'rack app' do
  describe 'X-Correlation-ID' do
    context 'without header' do
      before { get '/' }

      it 'is set' do
        expect(last_response.headers).to have_key('X-Correlation-ID')
      end
    end

    context 'with header' do
      before do
        header 'X-Correlation-ID', uuid
        get '/'
      end

      it 'is proxied' do
        expect(last_response.headers['X-Correlation-ID']).to eq(uuid)
      end
    end
  end
end
